/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

#include <qwidget.h>
#include "pdata.h"
#include "main.h"
#include <qscrollbar.h>
#include <qpainter.h>
#include <fcntl.h>
#include "qfont.h"

extern cnf mconf;

PData::PData(QWidget *parent, const char *name): QWidget(parent,name)
{
setBackgroundMode(PaletteBackground);
setPalette(QPalette(QColor(0,0,0)));
setBackgroundColor(QColor(0,0,0));
}

void PData::mkc_v(int maxx,int maxy,QPainter *p)
{
int i,j;
int x;
float xmag;
char s[10];

xmag=(float)maxx/(float)mconf.wave.window_length_pn;
p->setPen(QColor(mconf.col.wave_o.r,mconf.col.wave_o.g,mconf.col.wave_o.b));
p->drawLine(0,maxy/2-15,maxx,maxy/2-15);
p->setPen(QColor(mconf.col.wave_x.r,mconf.col.wave_x.g,mconf.col.wave_x.b));
p->drawLine(0,maxy-30,maxx,maxy-30);
j=0;
p->setPen(QColor(mconf.col.wave_xlines.r,mconf.col.wave_xlines.g,mconf.col.wave_xlines.b));
for (i=mconf.wave.window_start_pn;i<mconf.wave.window_start_pn+mconf.wave.window_length_pn;i++)
{
  if (i%(mconf.wave.window_length_pn/20)==0)
  {
    j++;
    x=(int)((float)(i-mconf.wave.window_start_pn)*xmag);
    if (j==5)
    {
       p->drawLine(x,maxy-20,x,maxy-30);
       sprintf(s,"%.2fs",(float)i/(float)(mconf.wave.freq));
       p->setPen(QColor(mconf.col.wave_xtext.r,mconf.col.wave_xtext.g,mconf.col.wave_xtext.b));
       p->drawText(x-(strlen(s)*3),maxy-5,s);
       p->setPen(QColor(mconf.col.wave_xlines.r,mconf.col.wave_xlines.g,mconf.col.wave_xlines.b));
       j=0;
    }
  else 
    p->drawLine(x,maxy-25,x,maxy-30);
  }    
}
}

void PData::paintEvent(QPaintEvent *)
{
int maxx;
int maxy,basey;
float step;
int step1;
int ee;
long i;
int avg;
float ymag;
QPainter pp;

maxx=width()-15;
maxy=height();
basey=maxy-30;
ymag=(float)(basey)/(float)255;
step=(float)(mconf.wave.window_length_pn)/(float)maxx;
if (step<1)
  step1=1;
else 
  step1=(int)step;
pp.begin(this);
mkc_v(maxx,maxy,&pp);
pp.setPen(QColor(mconf.col.wave_data.r,mconf.col.wave_data.g,mconf.col.wave_data.b));
ee=0;
if (mconf.wave.wave!=NULL)
  for (i=mconf.wave.window_start_pn;i<mconf.wave.window_start_pn+mconf.wave.window_length_pn;i=i+step1)
   {
      avg=(int)((*(mconf.wave.wave+i))*ymag);
      if (i>0) 
	pp.drawLine((i-mconf.wave.window_start_pn)/step-1,basey-ee,(i-mconf.wave.window_start_pn)/step,basey-avg);
      else 
        pp.drawLine((i-mconf.wave.window_start_pn)/(step),220-avg,(i-mconf.wave.window_start_pn)/step,220-avg);
      ee=avg;
   }
   mkc_v(maxx,maxy,&pp);
   pp.end();
}
